def fib(n):
    a = 0
    b = 1
    if n < 0:
        return -fib(-n)
    elif n == 0:
        return 0
    elif n == 1:
        return 1
    else:
        for i in range(1, n):
            a, b = b, a + b
        return b

def closest_pos(i):
    upper = 1
    while fib(upper) <= i:
        upper = upper * 2
    lower = int(upper/2)
    while upper-lower != 1:
        mid = int((lower+upper)/2)
        if fib(mid) <= i:
            lower = mid
        else:
            upper = mid
    return (lower, upper)

dic = {}

def fib_add(i):
    if not i in dic:
        dic[i] = fib_add_(i)
    return dic[i]
    
def fib_add_(i):
    if i == 1:
        return [1]
    if i == 0:
        return []
    smaller, larger = closest_pos(i)
    smaller = [smaller] + fib_add(i - fib(smaller))
    larger = [larger] + [-x for x in fib_add(-(i - fib(larger)))]
    if len(smaller) < len(larger):
        return smaller
    else:
        return larger
    
